/*	
	N-Rage`s Dinput8 Plugin -- V1.80a (23. 1. 2002)
    (C) 2002  Norbert Wladyka

	Author`s Email: norbert.wladyka@chello.at
	Website: http://go.to/nrage


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _FILEACCESS_H_
#define _FILEACCESS_H_

#include "NRage PluginV2.h"

BOOL GetDirectory( TCHAR *pszDirectory, WORD wDirID );
bool CheckFileExists( CONST LPTSTR FileName );
bool CreateMultipleDirs( CONST LPTSTR pszDirName );
void GetAbsoluteFileName( TCHAR *szAbsolute, CONST TCHAR *szFileName, CONST WORD wDirID );

BOOL SendFilestoList( HWND hDlgItem, WORD wType );
bool SaveRegString( TCHAR *szSubKey, int nSubNumber, TCHAR *pszStringName, TCHAR *pszString );
bool LoadRegValue( TCHAR *pszSubKey, int nSubNumber, TCHAR *pszKey, void *pData, DWORD *dwDataSize );
BOOL LoadConfigStructFromReg();
BOOL StoreConfigStructIntoRegistry();

bool LoadProfile( TCHAR *pszFileName, TCHAR *pszConfigname, CONTROLLER *pController, TCHAR *pszGameDevice, BYTE *bGameDeviceNr );
int FormatProfileBlock( TCHAR *szTextBlock, int iController );
bool BrowseFolders( HWND hwndParent, TCHAR *pszHeader, TCHAR *pszDirectory );
bool BrowseFile( HWND hDlg, TCHAR *pszFileName, DWORD dwType );
bool ReadMemPakFile( TCHAR *pszMemPakFile, BYTE *aMemPak, bool fCreate );
bool WriteMemPakFile( TCHAR *pszMemPakFile, BYTE *aMemPak, bool fCreate );
bool LoadProfileFromResource( int indexController, CONTROLLER *pController, TCHAR *pszGameDevice, BYTE *bGameDeviceNr );
void LoadShortCutsfromRessource( SHORTCUTS *pShortCuts );
bool LoadDeviceDesc( TCHAR *pszProductName, BYTE *bProductCounter, int indexController );
void LoadShortCuts( SHORTCUTS *pShortCuts );
BYTE LoadModifiers( MODIFIER **ppMods, int indexController );
bool LoadControllerStruct( CONTROLLER *pController, int indexController );


// RegistryKeys
#define STRING_REG_BASEKEY		"Software\\NRage\\DX8InputPlugin2"

#define STRING_REG_CONTROLLER	"Controller"
#define STRING_REG_FOLDERS		"Folders"
#define STRING_REG_BROWSER		"lastBrowserDir"

#define STRING_REG_SHORTCUTS	"ShortCuts"

#define STRING_REG_AUTOCONFIG	"AutoConfig"

#define STRING_REG_CONTROLS		"Controls"
#define STRING_REG_SETTINGS		"ControllerSettings"
#define STRING_REG_DEVICE		"DeviceSettings"
#define STRING_REG_RUMBLE		"RumbleSettings"
#define STRING_REG_MODIFIERS	"Modifiers"
#define STRING_REG_GAMEDEVICE	"GameDevice"
#define STRING_REG_GAMEDEVICENR	"GameDeviceNr"
#define STRING_REG_MEMPAKFILE	"MemPakFile"
#define STRING_REG_GBROMFILE	"GBRomFile"
#define STRING_REG_GBROMSAVE	"GBRomSave"

#define STRING_REG_MEMPAKDIR	"MemPaks"
#define STRING_REG_GBROMDIR		"GameBoy Roms"
#define STRING_REG_GBROMSDIR	"GameBoy Saves"

#define STRING_REG_BRPROFILE	"Profile"
#define STRING_REG_BRNOTE		"Note"
#define STRING_REG_BRMEMPAK		"Mempak"
#define STRING_REG_BRGBROM		"GBxRom"
#define STRING_REG_BRGBSAVE		"GBxSave"

#define STRING_DEF_MEMPAKFILE	"MemPaks"
#define STRING_DEF_GBROMFILE	"GBxRoms"
#define STRING_DEF_GBROMSAVE	"GBxSaves"

// Profiles
#define STRING_PROFILEVERSION	"Controller Profile 2.0"

#define CHK_PROFILEVERSION20 20830	// with @ in front

#define CHK_CONTROLS		3631
#define CHK_SETTINGS		17590
#define CHK_DEVICE			10575
#define CHK_RUMBLE			10588
#define CHK_MODIFIERS		4432
#define CHK_GAMEDEVICE		5149
#define CHK_GAMEDEVICENR	7305
#define CHK_MEMPAKFILE		5020
#define CHK_GBROMFILE		4092
#define CHK_GBROMSAVE		4179

#define PL_NOHIT				0	// nothing
#define PL_KEYNAME				1	// [KeyName]
#define PL_VERSIONSTRING		10	// @STRING_PROFILEVERSION

#define PL_CONTROLS			100
#define PL_SETTINGS			101
#define PL_DEVICE			102
#define PL_RUMBLE			103
#define PL_MODIFIERS		104
#define PL_GAMEDEVICE		105
#define PL_GAMEDEVICENR		106
#define PL_MEMPAKFILE		107
#define PL_GBROMFILE		108
#define PL_GBROMSAVE		109


#define DIRECTORY_APPLICATION	1
#define DIRECTORY_OWNFILES		2
#define DIRECTORY_MEMPAK		3
#define DIRECTORY_GBROMS		4
#define DIRECTORY_GBSAVES		5


#define FILIST_MEM			1
#define FILIST_TRANSFER		2

#define BF_LOAD				1
#define BF_SAVE				2

#define	BF_PROFILE			1
#define	BF_MEMPAK			2
#define BF_NOTE				3
#define	BF_GBROM			4
#define	BF_GBSAVE			5

#define	BF_BINARY			10

#endif // #ifndef _FILEACCESS_H_