#ifndef _GBCART_H_
#define _GBCART_H_

#include <windows.h>

typedef struct _GBCART
{
	int iCurrentRomBankNo;
	int iCurrentRamBankNo;
	bool bRamEnableState;
	char RamData[0x08 * 0x2000];
	char RamDataSafetyPadding[64];
	char RomData[0x40 * 0x4000];
	char RomDataSafetyPadding[64];
} GBCART, *LPGBCART;

bool LoadCart(LPGBCART Cart, LPCTSTR RomFile, LPCTSTR RamFile, LPCTSTR TdfFile);
bool ReadCart(LPGBCART Cart, DWORD dwAddress, BYTE *Data);
bool WriteCart(LPGBCART Cart, DWORD dwAddress, BYTE *Data);
bool SaveCart(LPGBCART Cart, LPTSTR SaveFile, LPTSTR TimeFile);
bool UnloadCart(LPGBCART Cart);

#define DebugWriteOneline( str ) DebugWrite( str )
#define DebugWriteByte( str ) DebugWrite( "%02X", str )
#define DebugWriteWord( str ) DebugWrite( "%04X", str )

#endif // #ifndef _GBCART_H_
